--conky apps - cpu section by mrpeachy 2010

--[[
in conky
lua_load /home/mcdowall/lua/apps.lua
lua_draw_hook_pre draw_fig
]]

require "cairo"

function conky_draw_fig()

	local updates = conky_parse('${updates}')
	updates = tonumber(updates)

	if conky_window == nil then return end
	local w = conky_window.width
	local h = conky_window.height
	local cs = cairo_xlib_surface_create(conky_window.display, conky_window.drawable, conky_window.visual, w, h)

	cr = cairo_create(cs)

--set up tables

	if updates == 5 then
		cpusecdata = {}
		cpusecdatal = 60
		cpumindata = {}
		cpumindatal = 60
		cpu5mindata = {}
		cpu5mindatal = 60
		cpu10mindata = {}
		cpu10mindatal = 60
		cpuavg = {0, 0, 0, 0, 0}
		cpuavgl = 5
	end

	if updates > 5 then
--set timers
		timer1 = (updates % 60) + 1--1 minute clock
		timer2 = (updates % (60 * 5)) + 1--5 minute clock
		timer3 = (updates % (60 * 10)) + 1--10 minute clock
		timer4 = (updates % (60 * 15)) + 1--15 minute clock
		timer5 = (updates % (60 * 30)) + 1--30 minute clock
		timer6 = (updates % (60 * 60)) + 1--1hour clock
--set second data
		cpu = tonumber(conky_parse("${cpu}"))
		for i = 1,tonumber(cpusecdatal) do
			if cpusecdata[i + 1] == nil then cpusecdata[i + 1] = 0 end
			cpusecdata[i] = cpusecdata[i + 1]
			if i == cpusecdatal then
				cpusecdata[cpusecdatal] = cpu
			end--if
		end--end for
--set cpu minute average data
		cpuminavg = 0
		if timer1 == 1 then
			for i = 1, tonumber(cpumindatal) do
				cpuminavg = cpuminavg + cpusecdata[i]
				if cpumindata[i + 1] == nil then cpumindata[i + 1] = 0 end
				cpumindata[i] = cpumindata[i + 1]
				if i == cpumindatal then
					cpumindata[cpumindatal] = cpuminavg/60
				end--if
			end--end for
		end--if timer
--set cpu 5 minute average data
		if timer2 == 1 then
			for i = 1, tonumber(cpu5mindatal) do
				if cpu5mindata[i + 1] == nil then cpu5mindata[i + 1] = 0 end
				cpu5mindata[i] = cpu5mindata[i + 1]
				if i == cpu5mindatal then
					cpu5mindata[cpu5mindatal] = (cpumindata[60] + cpumindata[59] + cpumindata[58] + cpumindata[57] + cpumindata[56])/5
				end--if
			end--end for
		end--if timer
--set cpu 10 minute average data
		if timer3 == 1 then
			for i = 1, tonumber(cpu10mindatal) do
				if cpu10mindata[i + 1] == nil then cpu10mindata[i + 1] = 0 end
				cpu10mindata[i] = cpu10mindata[i + 1]
				if i == cpu10mindatal then
					cpu10mindata[cpu10mindatal] = (cpu5mindata[60] + cpu5mindata[59])/2
				end--if
			end--end for
		end--if timer
--set exp decaying avg data
--average use over last periods

-- 5 minute exp decay avg
--300 seconds in 5 minutes
		if cpuavg[1] == nil then cpuavg[1] = 0 end
		cpuavg5m = cpuavg[1] * (299/300)
		cpuplus5m = cpu * (1/300)
		cpuavg[1] = cpuavg5m + cpuplus5m
--600 seconds in 10 minutes
		if cpuavg[2] == nil then cpuavg[2] = 0 end
		cpuavg10m = cpuavg[2] * (599/600)
		cpuplus10m = cpu * (1/600)
		cpuavg[2] = cpuavg10m + cpuplus10m
--900 seconds in 15 minutes
		if cpuavg[3] == nil then cpuavg[3] = 0 end
		cpuavg15m = cpuavg[3] * (899/900)
		cpuplus15m = cpu * (1/900)
		cpuavg[3] = cpuavg15m + cpuplus15m
--1800 seconds in 30 minutes
		if cpuavg[4] == nil then cpuavg[4] = 0 end
		cpuavg30m = cpuavg[4] * (1799/1800)
		cpuplus30m = cpu * (1/1800)
		cpuavg[4] = cpuavg30m + cpuplus30m
--3600 seconds in 1 hour
		if cpuavg[5] == nil then cpuavg[5] = 0 end
		cpuavg60m = cpuavg[5] * (3599/3600)
		cpuplus60m = cpu * (1/3600)
		cpuavg[5] = cpuavg60m + cpuplus60m

--############################################
--############################################
--draw graphs
--cpu second graph
		setx = 40.5
		sety = 10 --100.5  -- y - для всего окна
--set gap 
		gapy = 30

		for i = 1, tonumber(cpusecdatal) do
			cairo_set_line_width (cr, 1)
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
			adjust = 6
			heights = 80
			csgx = setx + 25
			csgy = sety + heights + gapy
			across = csgx
			down = csgy
			idata = (cpusecdata[i]/100) * heights
			iplus = (cpusecdata[i + 1]/100) * heights
			if iplus == 0 or iplus == nil then cairo_set_source_rgba (cr, 0, 0, 0, 0) end
			cairo_move_to (cr, across + (i*adjust), down - idata)
			cairo_line_to (cr,across + ((i + 1) * adjust), down - iplus)
			cairo_stroke (cr)
--grid marks
			cairo_move_to (cr, across + (i * adjust), down)
			cairo_set_source_rgba (cr, 1, 1, 1, 1)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heights/4)*1))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heights/4)*2))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heights/4)*3))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heights/4)*4))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			if i == 1 or i == 15 or i == 30 or i == 45 or i == 60 then

-- 1
				add = -(heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 2
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 3
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 4
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 5
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 6
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 7
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 8
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 9
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 10
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 11
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 12
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 13
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 14
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 15
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 16
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 17
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 18
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 19
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
-- 20
				add = add - (heights/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
			end--if
		end--end for

		font = "Ubuntu"
		fontsize = 12
		cairo_select_font_face (cr, font, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
		cairo_set_font_size (cr, fontsize)
		cairo_move_to (cr, across - 14, down - ((heights/4)*0))
		cairo_show_text (cr, "0%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heights/4)*1))
		cairo_show_text (cr, "25%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heights/4)*2))
		cairo_show_text (cr, "50%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heights/4)*3))
		cairo_show_text (cr, "75%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 26, down - ((heights/4)*4))
		cairo_show_text (cr, "100%")
		cairo_stroke (cr)

--x axis label
		downs = down + 10
		cairo_move_to (cr, across, downs)
		cairo_show_text (cr, "60")
		cairo_stroke (cr)

		add = adjust * 14
		cairo_move_to (cr, across + add, downs)
		cairo_show_text (cr, "45")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add, downs)
		cairo_show_text (cr, "30")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add, downs)
		cairo_show_text (cr, "15")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add + 2, downs)
		cairo_show_text (cr, "0")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 26, downs + 15)
		cairo_show_text (cr, "SECONDS")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 5, downs - heights - 15)
		cairo_show_text (cr, "CPU USAGE INCREMENTS OF 1 SECOND")
		cairo_stroke (cr)

-------------------------------------------------------------------------
--gap between graphs
		gap1 = 50
--cpu minute graph
		for i = 1, tonumber(cpumindatal) do
			cairo_set_line_width (cr, 1)
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
			adjust = 6
			heightm = 80
			across = csgx
			down = csgy + heightm + gap1
			if cpumindata[i] == nil then cpumindata[i] = 0 end
			if cpumindata[i + 1] == nil then cpumindata[i + 1] = 0 end
			idata = (cpumindata[i]/100) * heightm
			iplus = (cpumindata[i + 1]/100) * heightm
			if iplus == 0 or iplus == nil then cairo_set_source_rgba (cr, 0, 0, 0, 0) end
			cairo_move_to (cr, across + (i * adjust), down - idata)
			cairo_line_to (cr, across + ((i + 1) * adjust), down - iplus)
			cairo_stroke (cr)

--grid marks
			cairo_move_to (cr, across + (i * adjust), down)
			cairo_set_source_rgba (cr, 1, 1, 1, 1)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heightm/4)*1))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heightm/4)*2))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heightm/4)*3))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((heightm/4)*4))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			if i == 1 or i == 15 or i == 30 or i == 45 or i == 60 then

				add = -(heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (heightm/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
			end--if
		end--end for


		cairo_move_to (cr, across - 14, down - ((heightm/4)*0))
		cairo_show_text (cr, "0%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heightm/4)*1))
		cairo_show_text (cr, "25%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heightm/4)*2))
		cairo_show_text (cr, "50%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((heightm/4)*3))
		cairo_show_text (cr, "75%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 26, down - ((heightm/4)*4))
		cairo_show_text (cr, "100%")
		cairo_stroke (cr)
--x axis label
		downm = down + 10
		cairo_move_to (cr, across, downm)
		cairo_show_text (cr, "60")
		cairo_stroke (cr)

		add = adjust*14
		cairo_move_to (cr, across + add, downm)
		cairo_show_text (cr, "45")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add, downm)
		cairo_show_text (cr, "30")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add,downm)
		cairo_show_text (cr, "15")
		cairo_stroke (cr)

		add = add + adjust*15
		cairo_move_to (cr, across + add +2, downm)
		cairo_show_text (cr, "0")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 26, downm + 15)
		cairo_show_text (cr, "MINUTES")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 5, downm - heightm - 15)
		cairo_show_text (cr, "CPU USAGE INCREMENTS OF 1 MINUTE AVERAGE")
		cairo_stroke (cr)

---------------------------------------------------------------
--gap between graphs
		gap2 = 50
--cpu 5 minute graph
		for i = 1, tonumber(cpu5mindatal) do

			cairo_set_line_width (cr, 1)
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
			adjust = 6
			height5m = 80
			across = csgx
			down = csgy + height5m + gap2 + heightm + gap1
			if cpu5mindata[i] == nil then cpu5mindata[i] = 0 end
			if cpu5mindata[i + 1] == nil then cpu5mindata[i + 1] = 0 end
			idata = (cpu5mindata[i]/100) * height5m
			iplus = (cpu5mindata[i + 1]/100) * height5m
			if iplus == 0 or iplus == nil then cairo_set_source_rgba (cr, 0, 0, 0, 0) end

			cairo_move_to (cr, across + (i * adjust), down - idata)
			cairo_line_to (cr, across + ((i + 1) * adjust), down - iplus)
			cairo_stroke (cr)

--grid marks
			cairo_move_to (cr, across + (i * adjust), down)
			cairo_set_source_rgba (cr, 1, 1, 1, 1)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((height5m/4)*1))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((height5m/4)*2))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((height5m/4)*3))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			cairo_move_to (cr, across + (i * adjust), down - ((height5m/4)*4))
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			if i == 1 or i == 12 or i == 24 or i == 36 or i == 48 or i == 60 then

				add = -(height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)

				add = add - (height5m/20)
				cairo_move_to (cr, across + (i * adjust), down + add)
				cairo_rel_line_to (cr, 0, -0.5)
				cairo_stroke (cr)
			end--if
		end--end for

		cairo_move_to (cr, across - 14, down - ((height5m/4)*0))
		cairo_show_text (cr, "0%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((height5m/4)*1))
		cairo_show_text (cr, "25%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((height5m/4)*2))
		cairo_show_text (cr, "50%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 20, down - ((height5m/4)*3))
		cairo_show_text (cr, "75%")
		cairo_stroke (cr)

		cairo_move_to (cr, across - 26, down - ((height5m/4)*4))
		cairo_show_text (cr, "100%")
		cairo_stroke (cr)

--x axis label
		downm = down + 10

		cairo_move_to (cr, across + 2, downm)
		cairo_show_text (cr, "5")
		cairo_stroke (cr)

		add = adjust * 11
		cairo_move_to (cr, across + add + 2, downm)
		cairo_show_text (cr, "4")
		cairo_stroke (cr)

		add = add + adjust * 12
		cairo_move_to (cr, across + add + 2, downm)
		cairo_show_text (cr, "3")
		cairo_stroke (cr)

		add = add + adjust * 12
		cairo_move_to (cr, across + add + 2, downm)
		cairo_show_text (cr, "2")
		cairo_stroke (cr)

		add = add + adjust * 12
		cairo_move_to (cr, across + add + 2, downm)
		cairo_show_text (cr, "1")

		add = add + adjust * 12
		cairo_move_to (cr, across + add + 2, downm)
		cairo_show_text (cr, "0")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 26, downm + 15)
		cairo_show_text (cr, "HOURS")
		cairo_stroke (cr)

		cairo_move_to (cr, across + adjust * 5, downm - height5m - 15)
		cairo_show_text (cr, "CPU USAGE INCREMENTS OF 5 MINUTE AVERAGE")
		cairo_stroke (cr)

--#########################-----------------------------
--SHOW PROCESS DATA########
--#########################------------------------------

		adjp = 10

		acrossp = csgx + (adjust * cpusecdatal) + 30
		downp = downs - heights - 15
--title
		cairo_set_source_rgba (cr, 1, 1, 1, 1)
		cairo_move_to (cr, acrossp, downp)
		cairo_show_text (cr, "RUNNING PROCESSES")

		add = fontsize + ((fontsize/100)*adjp)
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, "BY CURRENT CPU")
--gap after title
		gappt = 10
		add1 = fontsize + ((fontsize/100)*adjp) + gappt + add
		cairo_move_to (cr, acrossp, downp + add1)
		cairo_show_text (cr, "PROCESS NAME")

		gappta = 120
		cairo_move_to (cr, acrossp + gappta, downp + add1)
		cairo_show_text (cr, "CPU")

		gapptb = 60
		cairo_move_to (cr, acrossp + gappta + gapptb, downp + add1)
		cairo_show_text (cr, "PID")
--process name
		tcput1 = string.upper(conky_parse('${top name 1}'))
		tcput2 = string.upper(conky_parse('${top name 2}'))
		tcput3 = string.upper(conky_parse('${top name 3}'))
		tcput4 = string.upper(conky_parse('${top name 4}'))
		tcput5 = string.upper(conky_parse('${top name 5}'))
		tcput6 = string.upper(conky_parse('${top name 6}'))
		tcput7 = string.upper(conky_parse('${top name 7}'))
		tcput8 = string.upper(conky_parse('${top name 8}'))
		tcput9 = string.upper(conky_parse('${top name 9}'))
		tcput10 = string.upper(conky_parse('${top name 10}'))
--process usage
		tcpun1 = string.upper(conky_parse('${top cpu 1}') .. "%")
		tcpun2 = string.upper(conky_parse('${top cpu 2}') .. "%")
		tcpun3 = string.upper(conky_parse('${top cpu 3}') .. "%")
		tcpun4 = string.upper(conky_parse('${top cpu 4}') .. "%")
		tcpun5 = string.upper(conky_parse('${top cpu 5}') .. "%")
		tcpun6 = string.upper(conky_parse('${top cpu 6}') .. "%")
		tcpun7 = string.upper(conky_parse('${top cpu 7}') .. "%")
		tcpun8 = string.upper(conky_parse('${top cpu 8}') .. "%")
		tcpun9 = string.upper(conky_parse('${top cpu 9}') .. "%")
		tcpun10 = string.upper(conky_parse('${top cpu 10}') .. "%")
--process pid
		tcpup1 = string.upper(conky_parse('${top pid 1}'))
		tcpup2 = string.upper(conky_parse('${top pid 2}'))
		tcpup3 = string.upper(conky_parse('${top pid 3}'))
		tcpup4 = string.upper(conky_parse('${top pid 4}'))
		tcpup5 = string.upper(conky_parse('${top pid 5}'))
		tcpup6 = string.upper(conky_parse('${top pid 6}'))
		tcpup7 = string.upper(conky_parse('${top pid 7}'))
		tcpup8 = string.upper(conky_parse('${top pid 8}'))
		tcpup9 = string.upper(conky_parse('${top pid 9}'))
		tcpup10 = string.upper(conky_parse('${top pid 10}'))
--print names
		cairo_set_source_rgba (cr, 1, 0, 0, 1)

		add = fontsize + ((fontsize/100)*adjp) + add1
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput1)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput2)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput3)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput4)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput5)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput6)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput7)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput8)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput9)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput10)

-----------------------------------------------
		add = fontsize + ((fontsize/100)*adjp) + add1
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun1)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun2)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun3)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun4)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun5)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun6)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun7)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun8)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun9)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun10)

-----------------------------------------------
		adjgp = 8--adjusts placement of pid under title

		add = fontsize + ((fontsize/100)*adjp) + add1
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup1)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup2)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup3)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup4)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup5)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup6)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp+add)
		cairo_show_text (cr, tcpup7)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup8)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup9)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta + gapptb - adjgp, downp + add)
		cairo_show_text (cr, tcpup10)

--show list of processes that have used the most?
--title
		downp = downp + 200
		cairo_set_source_rgba (cr, 1, 1, 1, 1)

		cairo_move_to (cr, acrossp, downp)
		cairo_show_text (cr, "RUNNING PROCESSES")

		add = fontsize + ((fontsize/100)*adjp)
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, "BY TOTAL CPU TIME")
--gap after title
		gappt = 10
		add1 = fontsize + ((fontsize/100)*adjp) + gappt + add
		cairo_move_to (cr, acrossp, downp + add1)
		cairo_show_text (cr, "PROCESS NAME")

		gappta = 150
		cairo_move_to (cr, acrossp + gappta, downp + add1)
		cairo_show_text (cr, "TIME")
--process name
		tcput1 = string.upper(conky_parse('${top_time name 1}'))
		tcput2 = string.upper(conky_parse('${top_time name 2}'))
		tcput3 = string.upper(conky_parse('${top_time name 3}'))
		tcput4 = string.upper(conky_parse('${top_time name 4}'))
		tcput5 = string.upper(conky_parse('${top_time name 5}'))
		tcput6 = string.upper(conky_parse('${top_time name 6}'))
		tcput7 = string.upper(conky_parse('${top_time name 7}'))
		tcput8 = string.upper(conky_parse('${top_time name 8}'))
		tcput9 = string.upper(conky_parse('${top_time name 9}'))
		tcput10 = string.upper(conky_parse('${top_time name 10}'))

--process usage
		tcpun1 = string.upper(conky_parse('${top_time time 1}'))
		tcpun2 = string.upper(conky_parse('${top_time time 2}'))
		tcpun3 = string.upper(conky_parse('${top_time time 3}'))
		tcpun4 = string.upper(conky_parse('${top_time time 4}'))
		tcpun5 = string.upper(conky_parse('${top_time time 5}'))
		tcpun6 = string.upper(conky_parse('${top_time time 6}'))
		tcpun7 = string.upper(conky_parse('${top_time time 7}'))
		tcpun8 = string.upper(conky_parse('${top_time time 8}'))
		tcpun9 = string.upper(conky_parse('${top_time time 9}'))
		tcpun10 = string.upper(conky_parse('${top_time time 10}'))
--print names
		cairo_set_source_rgba (cr, 1, 0, 0, 1)
		add = fontsize + ((fontsize/100)*adjp) + add1
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput1)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput2)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput3)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput4)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput5)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput6)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput7)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput8)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput9)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp, downp + add)
		cairo_show_text (cr, tcput10)

-----------------------------------------------
		add = fontsize + ((fontsize/100)*adjp) + add1
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun1)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun2)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun3)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun4)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun5)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun6)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun7)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun8)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun9)

		add = fontsize + ((fontsize/100)*adjp) + add
		cairo_move_to (cr, acrossp + gappta - 14, downp + add)
		cairo_show_text (cr, tcpun10)

		cairo_stroke (cr)

--print processor info at top

		fontsize = 14
		adjp = 10
		cairo_set_font_size (cr, fontsize)

		cairo_move_to (cr, setx, sety)
		cairo_set_source_rgba (cr, 1, 1, 1, 1)

		if updates == 6 or timer1 == 1 then
			local f = io.popen("cat /proc/cpuinfo | grep -n 'cpu MHz' |sed -n 1p | awk -F':' '{print $3}' | sed -e 's/^[ \t]*//'") -- runs command
			cpumhz = f:read("*a") -- read output of command
			f:close()
			local f = io.popen("cat /proc/cpuinfo | grep -n 'model name' |sed -n 1p | awk -F':' '{print $3}' | sed -e 's/^[ \t]*//'") -- runs command
			cputype = f:read("*a") -- read output of command
			f:close()

			cputype = string.gsub(cputype,'[\r\n]','')
		end

--		text = string.upper("PROCESSOR:".. cputype .. " AT " .. cpumhz .. "MHZ")
--		cairo_show_text (cr, text)
--		cairo_stroke (cr)
--exponentially decaying averages
		adjeda = 60
		downeda = sety + gapy + gap1 + gap2 + heights + heightm + height5m + adjeda
		acrosseda = setx + 0.5
		cairo_move_to (cr, acrosseda, downeda)
		cairo_show_text (cr, "EXPONENTIALLY DECAYING AVERAGES")
		cairo_stroke (cr)

		add = 22.5
		cairo_set_line_width (cr, 25)
		cairo_move_to (cr, acrosseda + add, downeda + 110)

		if updates > 308 then
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
		else
			cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1)
		end

		cairo_rel_line_to (cr, 0, -cpuavg[1])
		cairo_stroke (cr)

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 110)

		if updates > 608 then
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
		else
			cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1)
		end

		cairo_rel_line_to (cr, 0, -cpuavg[2])
		cairo_stroke (cr)

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 110)

		if updates > 908 then
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
		else
			cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1)
		end

		cairo_rel_line_to (cr, 0, -cpuavg[3])
		cairo_stroke (cr)

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 110)

		if updates > 1808 then
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
		else
			cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1)
		end

		cairo_rel_line_to (cr, 0, -cpuavg[4])
		cairo_stroke (cr)

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 110)

		if updates > 3608 then
			cairo_set_source_rgba (cr, 1, 0, 0, 1)
		else
			cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1)
		end

		cairo_rel_line_to (cr, 0, -cpuavg[5])
		cairo_stroke (cr)

--labels

		add = 8
		cairo_move_to (cr, acrosseda + add, downeda + 125)
		fontsize = 12
		adjeda = 60
		cairo_set_line_width (cr, 1)
		cairo_set_source_rgba (cr, 1, 1, 1, 1)
		cairo_set_font_size (cr, fontsize)
		cairo_show_text (cr, "5MIN")

		add = 46 + add
		cairo_move_to (cr, acrosseda + add, downeda + 125)
		cairo_show_text (cr, "10MIN")

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 125)
		cairo_show_text (cr, "15MIN")

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 125)
		cairo_show_text (cr, "30MIN")

		add = 50 + add
		cairo_move_to (cr, acrosseda + add, downeda + 125)
		cairo_show_text (cr, "60MIN")
--note
		cairo_move_to (cr, acrosseda, downeda + 145)
--		font = "Ubuntu"
		fontsize = 10
		cairo_set_source_rgba (cr, 1, 1, 1, 1)
--		cairo_select_font_face (cr, font, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
		cairo_set_font_size (cr, fontsize)
		cairo_show_text (cr, "*NOT VALID WHILE BARS ARE GREY")
--dotty bar surrounds
		for i = 1, 10 do
			adjust = 25
			heights = 100
			across = acrosseda - 15.5
			down = downeda + 110
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = -(heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			add = add - (heights/20)
			cairo_move_to (cr, across + (i*adjust), down + add)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)
		end--do

		for i = 1, 5 do
			adjust = 5
			across = acrosseda + 9.5
			down = downeda + 110
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr,0,-0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 50
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 100
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 150
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 200
			cairo_move_to (cr, across + (i*adjust), down)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5
			cairo_move_to (cr, across + (i*adjust), down - 100)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 50
			cairo_move_to (cr, across + (i*adjust), down - 100)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 100
			cairo_move_to (cr, across + (i*adjust), down - 100)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 150
			cairo_move_to (cr, across + (i*adjust), down - 100)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 200
			cairo_move_to (cr, across + (i*adjust), down - 100)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5
			cairo_move_to (cr, across + (i*adjust), down - 25)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 50
			cairo_move_to (cr, across + (i*adjust), down - 25)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 100
			cairo_move_to (cr, across + (i*adjust), down - 25)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 150
			cairo_move_to (cr, across + (i*adjust), down - 25)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 200
			cairo_move_to (cr, across + (i*adjust), down - 25)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5
			cairo_move_to (cr, across + (i*adjust), down - 50)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 50
			cairo_move_to (cr, across + (i*adjust), down - 50)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 100
			cairo_move_to (cr, across + (i*adjust), down - 50)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 150
			cairo_move_to (cr, across + (i*adjust), down - 50)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 200
			cairo_move_to (cr, across + (i*adjust), down - 50)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5
			cairo_move_to (cr, across + (i*adjust), down - 75)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 50
			cairo_move_to (cr, across + (i*adjust), down - 75)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 100
			cairo_move_to (cr, across + (i*adjust), down - 75)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 150
			cairo_move_to (cr, across + (i*adjust), down-75)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)

			across = acrosseda + 9.5 + 200
			cairo_move_to (cr, across + (i*adjust), down - 75)
			cairo_rel_line_to (cr, 0, -0.5)
			cairo_stroke (cr)
		end
--cpuring
		cairo_set_line_width (cr, 20)
		cairo_set_source_rgba (cr, 1, 0, 0, 1)
		radius = 60
		cairo_arc (cr, 420, downeda + 60, radius, -1 * (90*(math.pi/180)), -1 *(90*(math.pi/180)) + ((math.pi*2)/100) * cpu)
		cairo_stroke (cr)
--dotty ring outer boundary
		around = 90

		for i = 1, around do
			cairo_set_line_width (cr, 1.5)
			radius = 70
			arc = (2*math.pi/around) * i
			cx1 = 0 + radius*(math.sin(arc))
			cy1 = 0 - radius*(math.cos(arc))
			radius = radius + 1
			arc = (2*math.pi/around) * i
			cx2 = 0 + radius*(math.sin(arc))
			cy2 = 0 - radius*(math.cos(arc))
			cairo_set_source_rgba (cr, 1, 1, 1, 1)
			cairo_move_to (cr, 420 + cx1, downeda + 60 + cy1)
			cairo_line_to (cr, 420 + cx2, downeda + 60 + cy2)
			cairo_stroke (cr)
		end

		around = 60

		for i = 1, around do
			radius = 49
			arc = (2*math.pi/around) * i
			cx1 = 0 + radius*(math.sin(arc))
			cy1 = 0 - radius*(math.cos(arc))
			radius = radius + 1
			arc = (2*math.pi/around) * i
			cx2 = 0 + radius*(math.sin(arc))
			cy2 = 0 - radius*(math.cos(arc))
			cairo_set_source_rgba (cr, 1, 1, 1, 1)
			cairo_move_to (cr, 420 + cx1, downeda + 60 + cy1)
			cairo_line_to (cr, 420 + cx2, downeda + 60 + cy2)
			cairo_stroke (cr)
		end

		for i = 1, 10 do
			n = i
			around = 10
			for i = 1, 5 do
				radius = 50 + i * 4
				arc = (2*math.pi/around) * n
				cx1 = 0 + radius*(math.sin(arc))
				cy1 = 0 - radius*(math.cos(arc))
				radius = radius + 1
				arc = (2*math.pi/around) * n
				cx2 = 0 + radius*(math.sin(arc))
				cy2 = 0 - radius*(math.cos(arc))
				cairo_set_source_rgba (cr, 1, 1, 1, 1)
				cairo_move_to (cr, 420 + cx1, downeda + 60 + cy1)
				cairo_line_to (cr, 420 + cx2, downeda + 60 + cy2)
				cairo_stroke (cr)
			end
		end

		fontsize = 36
		adjcnx = -28
		adjcny = 10
		cairo_set_source_rgba (cr, 1, 1, 1, 1)
		cairo_set_font_size (cr, fontsize)
		cairo_move_to (cr, 420 + adjcnx, downeda + 60 + adjcny)
		cairo_show_text (cr, cpu .. "%")
		cairo_stroke (cr)

	end--of if updates >5
end--of function
