--[[ конки "Системный монитор" сделан на идеи conky apps - cpu section by mrpeachy 2010
Выводит нагрузку процессора в реальном времени, а так же среднюю нагрузку за минуту и пять минут

by olgmen 29.03.2011 v.01

Для подключения скрипта добавьте в conkyrc следующие строки выше слова TEXT

lua_load ~/schedule/scripts/graph1.lua
lua_draw_hook_pre draw_graph
]]

require "cairo"

function conky_draw_graph()

	graph_settings = {

	{
	name = "cpu",
	arg = "cpu0",
	max = 100,
	x = 50,
	y = 30,
	width = 240,
	height = 100,
	color_graph = 0xff0000,
	},

	}

	if conky_window==nil then return end

	local updates = conky_parse('${updates}')
	updates = tonumber(updates)

	local cs=cairo_xlib_surface_create(conky_window.display,
		conky_window.drawable, 
		conky_window.visual, conky_window.width, conky_window.height)
	cr=cairo_create(cs)

	for i,v in pairs(graph_settings) do
		display_graph(v)
	end

	cairo_destroy(cr)
end
-- --------------------------------------------------------
-- функция перекодировки цвета

	function rgb_to_r_g_b(colour,alpha)	
		return ((colour / 0x10000) % 0x100) / 255., ((colour / 0x100) % 0x100) / 255., (colour % 0x100) / 255., alpha
	end

-- --------------------------------------------------------

function display_graph(t)

-- проверяем введенные параметры и устанавливаем параметры по умолчанию

	if t.name		== nil then t.name = "time" end
	if t.arg		== nil then t.arg = "%S" end
	if t.max		== nil then t.max = 60 end
	if t.samples		== nil then t.samples = 60 end
	if t.x			== nil then t.x = 170 end
	if t.y			== nil then t.y = 50 end
	if t.width		== nil then t.width = 100 end
	if t.height		== nil then t.height = 75 end
	if t.line_thickness	== nil then t.line_thickness = 1.5 end
	if t.color_line		== nil then t.color_line = 0xFFFFFF end
	if t.alpha_line		== nil then t.alpha_line = 1 end
	if t.color_graph	== nil then t.color_graph = 0xff0000 end
	if t.alpha_graph	== nil then t.alpha_graph = 1 end
	if t.font_name		== nil then t.font_name = "Ubuntu" end
	if t.font_size		== nil then t.font_size = 10 end
	if t.italic		== nil then t.italic = false end
	if t.bold		== nil then t.bold = false end

	local slant = CAIRO_FONT_SLANT_NORMAL
	local weight = CAIRO_FONT_WEIGHT_NORMAL
	if t.italic then slant = CAIRO_FONT_SLANT_ITALIC end
	if t.bold then weight = CAIRO_FONT_WEIGHT_BOLD end

	cairo_select_font_face(cr, t.font_name, slant, weight)
	cairo_set_font_size(cr, t.font_size)

	local updates = conky_parse('${updates}')
	updates = tonumber(updates)
-- сюда будем записывать данные
	if updates == 5 then
		ValueSecData = {}
		ValueMinData = {}
		Value5MinData = {}
	end

	if updates > 5 then
-- устанавка таймеров
		timer1 = (updates % 60) + 1		--1 minute clock
		timer2 = (updates % (60 * 5)) + 1	--5 minute clock
-- забираем данные
		value = tonumber(conky_parse(string.format('${%s %s}', t.name, t.arg)))
		if value == nil then value = 0 end
-- записываем данные каждую секунду
		for i = 1,tonumber(t.samples) do
			if ValueSecData[i + 1] == nil then ValueSecData[i + 1] = 0 end
			ValueSecData[i] = ValueSecData[i + 1]
			if i == t.samples then
				ValueSecData[t.samples] = value
			end
		end
-- записываем средние данные за минуту
		ValueMinAverage = 0
		if timer1 == 1 then
			for i = 1, tonumber(t.samples) do
				ValueMinAverage = ValueMinAverage + ValueSecData[i]
				if ValueMinData[i + 1] == nil then ValueMinData[i + 1] = 0 end
				ValueMinData[i] = ValueMinData[i + 1]
				if i == t.samples then
					ValueMinData[t.samples] = ValueMinAverage/60
				end
			end
		end
-- записываем средние данные за 5 минут
		if timer2 == 1 then
			for i = 1, tonumber(t.samples) do
				if Value5MinData[i + 1] == nil then Value5MinData[i + 1] = 0 end
				Value5MinData[i] = Value5MinData[i + 1]
				if i == t.samples then
					Value5MinData[t.samples] = (ValueMinData[60] + ValueMinData[59] + ValueMinData[58] + ValueMinData[57] + ValueMinData[56])/5
				end
			end
		end
-- рисуем сетку
		cairo_save(cr)
		cairo_set_line_width(cr, 1)
		cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_line, t.alpha_line))
-- горизонтальные линии
		for h = 0, 4, 1 do
			cairo_move_to(cr, t.x, t.y + t.height - h * t.height/4)
			cairo_rel_line_to(cr, t.width, 0)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- вертикальные линии
		for v = 0, 4, 1 do
			cairo_move_to(cr, t.x + t.width - v * t.width/4, t.y)
			cairo_rel_line_to(cr, 0, t.height)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- шкала Х
		txt = 60
		for v = 0, 4, 1 do
			cairo_move_to (cr, t.x + t.width - v * t.width/4, t.y + t.height * 1.2)
			cairo_show_text(cr, txt)
			txt = txt - 15
		end
-- шкала Y
		txt = 0
		for h = 0, 4, 1 do
			cairo_move_to (cr, t.x * 0.2, t.y + t.height - h * t.height/4)
			cairo_show_text(cr, txt .. " %")
			txt = txt + 25
		end

		cairo_move_to (cr, t.x * 1.2, t.y - t.y * 0.3)
		cairo_show_text (cr, t.name .. " = " .. value .. "%")

		cairo_move_to (cr, t.x + t.width * 0.75, t.y - t.y * 0.2)
		cairo_show_text (cr, "секунды")

		cairo_stroke(cr)
		cairo_restore(cr)

		for i = 1, tonumber(t.samples) do
			cairo_set_line_width (cr, t.line_thickness)
			cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_graph, t.alpha_graph))

			idata = (ValueSecData[i]/t.max) * t.height
			iplus = (ValueSecData[i + 1]/t.max) * t.height
-- если данных нет то ничего не выводится
			if iplus == 0 or iplus == nil then
				cairo_set_source_rgba (cr, 0, 0, 0, 0)
			end
			cairo_move_to (cr, t.x + t.width + t.line_thickness*2 - (i*t.width/t.samples), t.y + t.height - idata)
			cairo_line_to (cr, t.x + t.width + t.line_thickness*2 - ((i + 1) * t.width/t.samples), t.y + t.height - iplus)
			cairo_stroke (cr)
		end
-------------------------------------------------------------------------
-- среднее значение каждую минуту
		gap = t.height*1.5

		cairo_save(cr)
		cairo_set_line_width(cr, 1)
		cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_line, t.alpha_line))
-- горизонтальные линии
		for h = 0, 4, 1 do
			cairo_move_to(cr, t.x, t.y + gap + t.height - h * t.height/4)
			cairo_rel_line_to(cr, t.width, 0)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- вертикальные линии
		for v = 0, 4, 1 do
			cairo_move_to(cr, t.x + t.width - v * t.width/4, t.y + gap)
			cairo_rel_line_to(cr, 0, t.height)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- шкала Х
		txt = 60
		for v = 0, 4, 1 do
			cairo_move_to (cr, t.x + t.width - v * t.width/4, t.y + gap + t.height * 1.2)
			cairo_show_text(cr, txt)
			txt = txt - 15
		end
-- шкала Y
		txt = 0
		for h = 0, 4, 1 do
			cairo_move_to (cr, t.x * 0.2, t.y + gap + t.height - h * t.height/4)
			cairo_show_text(cr, txt .. " %")
			txt = txt + 25
		end

		cairo_move_to (cr, t.x + t.width * 0.75, t.y + gap - t.y * 0.2)
		cairo_show_text (cr, "минуты")

		cairo_stroke(cr)
		cairo_restore(cr)

		for i = 1, tonumber(t.samples) do
			cairo_set_line_width (cr, t.line_thickness)
			cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_graph, t.alpha_graph))
			if ValueMinData[i] == nil then ValueMinData[i] = 0 end
			if ValueMinData[i + 1] == nil then ValueMinData[i + 1] = 0 end
			idata = (ValueMinData[i]/t.max) * t.height
			iplus = (ValueMinData[i + 1]/t.max) * t.height
-- если данных нет, то ничего не выводится
			if iplus == 0 or iplus == nil then 					cairo_set_source_rgba (cr, 0, 0, 0, 0)
			end
			cairo_move_to (cr, t.x + t.width + t.line_thickness*2 - (i*t.width/t.samples), t.y + gap + t.height - idata)
			cairo_line_to (cr, t.x + t.width + t.line_thickness*2 - ((i + 1) * t.width/t.samples), t.y + gap + t.height - iplus)
			cairo_stroke (cr)
		end
---------------------------------------------------------------
-- значение каждые 5 минут
		gap1 = t.height * 3

		cairo_save(cr)
		cairo_set_line_width(cr, 1)
		cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_line, t.alpha_line))
-- горизонтальные линии
		for h = 0, 4, 1 do
			cairo_move_to(cr, t.x, t.y + gap1 + t.height - h * t.height/4)
			cairo_rel_line_to(cr, t.width, 0)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- вертикальные линии
		for v = 0, 5, 1 do
			cairo_move_to(cr, t.x + t.width - v * t.width/5, t.y + gap1)
			cairo_rel_line_to(cr, 0, t.height)
			cairo_set_dash(cr, 2, 1, 0)
		end
-- шкала Х
		txt = 60

		for v = 0, 5, 1 do
			cairo_move_to (cr, t.x + t.width - v * t.width/5, t.y + gap1 + t.height * 1.2)
			cairo_show_text(cr, 5-v)
		end
-- шкала Y
		txt = 0

		for h = 0, 4, 1 do
			cairo_move_to (cr, t.x * 0.2, t.y + gap1 + t.height - h * t.height/4)
			cairo_show_text(cr, txt .. " %")
			txt = txt + 25
		end

		cairo_move_to (cr, t.x + t.width * 0.75, t.y + gap1 - t.y * 0.2)
		cairo_show_text (cr, "часы")

		cairo_stroke(cr)
		cairo_restore(cr)
-- среднее значение каждые 5 минут
		for i = 1, tonumber(t.samples) do
			cairo_set_line_width (cr, t.line_thickness)
			cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_graph, t.alpha_graph))
			if Value5MinData[i] == nil then Value5MinData[i] = 0 end
			if Value5MinData[i + 1] == nil then Value5MinData[i + 1] = 0 end
			idata = (Value5MinData[i]/t.max) * t.height
			iplus = (Value5MinData[i + 1]/t.max) * t.height
-- если данных нет то ничего не выводится
			if iplus == 0 or iplus == nil then 					cairo_set_source_rgba (cr, 0, 0, 0, 0)
			end
			cairo_move_to (cr, t.x + t.width + t.line_thickness*2 - (i*t.width/t.samples), t.y + gap1 + t.height - idata)
			cairo_line_to (cr, t.x + t.width + t.line_thickness*2 - ((i + 1) * t.width/t.samples), t.y + gap1 + t.height - iplus)
			cairo_stroke (cr)
		end
	end
-- вывод процессов
	cairo_set_source_rgba(cr,rgb_to_r_g_b(t.color_line, t.alpha_line))
	cairo_move_to (cr, t.x * 0.2, t.y + t.height * 4.5)
	cairo_show_text (cr, "PROCESS NAME")
	cairo_move_to (cr, t.x + t.width/3, t.y + t.height * 4.5)
	cairo_show_text (cr, "MEMORY")
	cairo_move_to (cr, t.x + t.width*0.83, t.y + t.height * 4.5)
	cairo_show_text (cr, "CPU")
-- выводим 10 процессов
	for i = 1, 10, 1 do
		cairo_move_to (cr, t.x * 0.2, t.y + t.height * 4.5 + (i) * t.font_size*1.2)
		name = conky_parse("${top name "..(i).."}")
		cairo_show_text(cr, name)
		cairo_move_to (cr, t.x + t.width/3, t.y + t.height * 4.5 + (i) * t.font_size*1.2)
		memory = conky_parse("${top mem "..(i).."}") .. "%"
		cairo_show_text(cr, memory)
		cairo_move_to (cr, t.x + t.width*0.8, t.y + t.height * 4.5 + (i) * t.font_size*1.2)
		perc = conky_parse("${top cpu "..(i).."}") .. "%"
		cairo_show_text(cr, perc)
	end
end
